@echo off
title My Hero Academia - One's Justice - Multi-Language Translation Patch
setlocal EnableDelayedExpansion
set "hactool=tools\hactool.exe"
set "heropatcher=tools\heropatcher.exe"
set "quickbms=tools\quickbms.exe"
set "unpack=tools\unreal_tournament_4.bms"
set "u4pak=tools\u4pak.py"
set "keys=keys.txt"
set "ncaname="
set "ncasize=0"
set "padding=               "
set "minspace=    13421772800"

if not exist "%hactool%" (
	echo Error: hactool not found^^!
	goto end
)
if not exist "%heropatcher%" (
	echo Error: heropatcher not found^^!
	goto end
)
if not exist "%quickbms%" (
	echo Error: QuickBMS not found^^!
	goto end
)
if not exist "%unpack%" (
	echo Error: unreal_tournament_4.bms not found^^!
	goto end
)
if not exist "%u4pak%" (
	echo Error: u4pak.py not found^^!
	goto end
)
if not exist "%keys%" (
	echo Error: Keys not found^^!
	goto end
)
python -V > nul 2> nul
if %errorlevel%==9009 (
	echo Error: Python is not installed^^! Go to www.python.org/downloads/release/python-2715
	goto end
)
if not exist "%~1" (
	echo Error: Unable to open the file!
	goto end
)
for /f "tokens=2" %%A in (
  'wmic LogicalDisk Get DeviceID^,FreeSpace ^| %windir%\System32\find.exe /i "%~d0"'
) do set "freespace=%padding%%%A"
set "freespace=%freespace:~-15%"
if "%freespace%" LSS "%minspace%" (
  echo Error: You must have at least 12.5 GB of free hard drive space^^!
  goto end
)

:choosecfw
set /p cfw="Type the custom firmware you are using (atmosphere, ReiNX, sxos): "
if "%cfw%" == "atmosphere" goto chooselang
if "%cfw%" == "ReiNX" goto chooselang
if "%cfw%" == "sxos" (
	echo Warning: The patch won't work on SX OS 1.8 and 1.9^^!
	goto chooselang
)
echo Error: Type a valid custom firmware^^!
goto choosecfw

:chooselang
set /p language="Type a language (en-US, fr, it, de, es, pt-BR, es-419, ko, zh-Hant): "
if "%language%" == "en-US" goto setkey
if "%language%" == "fr" goto setkey
if "%language%" == "it" goto setkey
if "%language%" == "de" goto setkey
if "%language%" == "es" goto setkey
if "%language%" == "pt-BR" goto setkey
if "%language%" == "es-419" goto setkey
if "%language%" == "ko" goto setkey
if "%language%" == "zh-Hant" goto setkey
echo Error: Type a valid language^^!
goto chooselang

:error
echo Error: Something went wrong^^!
goto end

:setkey
set /p titlekey="Enter the TitleKey: "
goto choosefirm

:choosefirm
set /p firm="Are you using 1.0.2 (yes, no): "
if "%firm%" == "yes" goto main
if "%firm%" == "no" goto main
echo Error: Type a valid answer^^!
goto choosefirm

:main
echo Extracting the NCAs...
mkdir "hero_temp" > nul 2> nul
%hactool% -k %keys% --titlekey=%titlekey% --intype=xci --securedir=hero_temp\ncas "%~1" > nul 2> nul
%hactool% -k %keys% --titlekey=%titlekey% --intype=pfs0 --pfs0dir=hero_temp\ncas "%~1" > nul 2> nul
:findnca
for /r %%i in (hero_temp\ncas\*) do (
	if !ncasize! LSS %%~zi (
		set ncaname=%%~ni.nca
		set ncasize=%%~zi
	)
)
if not exist "hero_temp\ncas\%ncaname%" goto error
echo Extracting the RomFS...
%hactool% -k %keys% --titlekey=%titlekey% --romfsdir=hero_temp\romfs "hero_temp\ncas\%ncaname%" > nul 2> nul
rmdir "hero_temp\ncas" /S /Q > nul 2> nul
if not exist "hero_temp\romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" (
	if "%titlekey%" == "" (
		echo Warning: The dump may be corrupted or the NCA may be encrypted^^!
		set /p titlekey="Try to insert the title key: "
		echo Extracting the NCAs...
		%hactool% -k %keys% --titlekey=%titlekey% --intype=pfs0 --pfs0dir=hero_temp\ncas "%~1" > nul 2> nul
		goto findnca
	)
	goto error
)
echo Extracting the game files...
%quickbms% -Y %unpack% "hero_temp\romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" "hero_temp\pak" > nul 2> nul
title My Hero Academia - One's Justice - Multi-Language Translation Patch
rmdir "hero_temp\romfs" /S /Q > nul 2> nul
if not exist "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" (
	echo Can't find the text files^^!
	echo Error: The dump may be corrupted^^!
	goto end
)
if not exist "hero_temp\pak\HeroGame\Content\L10N\%language%\GUI\" (
	echo Can't find the textures^^!
	echo Error: The dump may be corrupted^^!
	goto end
)
echo Patching the files...
echo D|xcopy "hero_temp\pak\HeroGame\Content\L10N\%language%\GUI" "HeroGame\Content\GUI" /s /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" "HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" "HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" "HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" "HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" /y > nul 2> nul
%heropatcher% -common -%language% "HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" > nul 2> nul
%heropatcher% -ingame -%language% "HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" > nul 2> nul
%heropatcher% -outgame -%language% "HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" > nul 2> nul
%heropatcher% -story -%language% "HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" > nul 2> nul
rmdir "hero_temp" /S /Q > nul 2> nul
echo Repacking the patched files...
mkdir "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks" > nul 2> nul
if %firm% == "no" python %u4pak% "pack" "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks\HeroGame-Switch_1_P.pak" "HeroGame" > nul 2> nul
if %firm% == "yes" python %u4pak% "pack" "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks\HeroGame-Switch_0_P.pak" "HeroGame" > nul 2> nul
rmdir "HeroGame" /S /Q > nul 2> nul
if not exist "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks\HeroGame-Switch_1_P.pak" (
	python -V
	echo You should try with another version of Python.
	goto error
)
echo Plus Ultra^^!

:end
rmdir "hero_temp" /S /Q > nul 2> nul
pause
exit